"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var index_1 = require("../index");
var dynamodb_1 = require("aws-sdk/clients/dynamodb");
var docClient = new dynamodb_1.DocumentClient({
    region: 'ap-southeast-1'
});
var TABLE = 'Static-Table';
var dataModel = new index_1.DynamodbUtil('Static-Table', {
    region: 'ap-southeast-1'
});
beforeAll(function () { return initDatabase(); });
afterAll(function () { return clearDatabase(); });
// const dynamodb = new DynamodbUtil()
describe('DynamoDBUtil Test Suite', function () {
    describe('jest testing', function () {
        test('simple test', function () { return __awaiter(void 0, void 0, void 0, function () {
            return __generator(this, function (_a) {
                expect(1).toBe(1);
                return [2 /*return*/];
            });
        }); });
    });
    describe('attributes projection test', function () {
        test('scan with attributes', function () { return __awaiter(void 0, void 0, void 0, function () {
            var result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, dataModel.scan({
                            filter: {
                                _pkey: 'Album1'
                            },
                            attributes: ['artist', '_pkey'],
                        })];
                    case 1:
                        result = _a.sent();
                        expect(result).toEqual(expect.arrayContaining([
                            expect.objectContaining({ _pkey: 'Album1', artist: expect.any(String) })
                        ]));
                        return [2 /*return*/];
                }
            });
        }); });
        test('query with attributes', function () { return __awaiter(void 0, void 0, void 0, function () {
            var result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, dataModel.query({
                            keyCondition: {
                                _pkey: 'Album1'
                            },
                            attributes: ['artist', '_pkey', 'attribute.duration'],
                        })];
                    case 1:
                        result = _a.sent();
                        // console.log(result);
                        expect(result).toEqual(expect.arrayContaining([
                            expect.objectContaining({ _pkey: 'Album1', artist: expect.any(String) })
                        ]));
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('raw documentClient testing', function () {
        test('scan by raw', function () { return __awaiter(void 0, void 0, void 0, function () {
            var result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, dataModel.raw.scan({
                            TableName: 'Static-Table',
                        }).promise()];
                    case 1:
                        result = _a.sent();
                        // console.log(result);
                        expect(result.Items).toEqual(expect.arrayContaining([
                            expect.objectContaining({ _pkey: 'Album2', _skey: 'Album2#Araiva#Track1' })
                        ]));
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('query test', function () {
        test('query with function beginsWith', function () { return __awaiter(void 0, void 0, void 0, function () {
            var result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, dataModel.query({
                            keyCondition: {
                                _pkey: 'Album1',
                                _skey: {
                                    beginsWith: 'Album1#Araiva'
                                }
                            }
                        })];
                    case 1:
                        result = _a.sent();
                        // expect(result).toContain([
                        //   expect.objectContaining({ _pkey: 'Album1', _skey: 'Album1#Araiva#Track1' }),
                        //   expect.objectContaining({ _pkey: 'Album1', _skey: 'Album1#Araiva#Track2' }),
                        //   expect.objectContaining({ _pkey: 'Album1', _skey: 'Album1#Araiva#Track3' })
                        // ]);
                        expect(result).toHaveLength(3);
                        return [2 /*return*/];
                }
            });
        }); });
        test('query with function beginsWith and filter', function () { return __awaiter(void 0, void 0, void 0, function () {
            var result;
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, dataModel.query({
                            keyCondition: {
                                _pkey: 'Album1',
                                _skey: {
                                    beginsWith: 'Album1#Araiva'
                                }
                            },
                            filter: (_a = {},
                                _a['song'] = 'song theme 12',
                                _a)
                        })];
                    case 1:
                        result = _b.sent();
                        expect(result).toEqual(expect.arrayContaining([
                            expect.objectContaining({ _pkey: 'Album1', _skey: 'Album1#Araiva#Track2' })
                        ]));
                        expect(result).toHaveLength(1);
                        return [2 /*return*/];
                }
            });
        }); });
        test('query with sort DESC', function () { return __awaiter(void 0, void 0, void 0, function () {
            var result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, dataModel.query({
                            keyCondition: {
                                _pkey: 'Album1',
                            },
                            sort: 'DESC'
                        })];
                    case 1:
                        result = _a.sent();
                        expect(result[0]).toMatchObject({
                            _pkey: 'Album1',
                            _skey: 'Album1#Virus#Track5'
                        });
                        return [2 /*return*/];
                }
            });
        }); });
        test('query with attributes DESC', function () { return __awaiter(void 0, void 0, void 0, function () {
            var result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, dataModel.query({
                            keyCondition: {
                                _pkey: 'Album1',
                            },
                            attributes: ['artist']
                        })];
                    case 1:
                        result = _a.sent();
                        expect(result[0]).toMatchObject({
                            artist: expect.any(String),
                        });
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('scan', function () {
        test('scan with function equal and nested object', function () { return __awaiter(void 0, void 0, void 0, function () {
            var result;
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, dataModel.scan({
                            filter: (_a = {},
                                _a['artist'] = 'Araiva',
                                _a['attribute.country'] = 'Japan',
                                _a)
                        })];
                    case 1:
                        result = _b.sent();
                        expect(result).toEqual(expect.arrayContaining([
                            expect.objectContaining({ _pkey: 'Album1', _skey: 'Album1#Araiva#Track3' })
                        ]));
                        expect(result).toHaveLength(1);
                        return [2 /*return*/];
                }
            });
        }); });
        test('scan with function contains', function () { return __awaiter(void 0, void 0, void 0, function () {
            var result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, dataModel.scan({
                            filter: {
                                _skey: {
                                    contains: 'Virus'
                                },
                            }
                        })];
                    case 1:
                        result = _a.sent();
                        expect(result).toEqual(expect.arrayContaining([
                            expect.objectContaining({ artist: 'Virus' })
                        ]));
                        expect(result).toHaveLength(3);
                        return [2 /*return*/];
                }
            });
        }); });
        test('scan with lastKey', function () { return __awaiter(void 0, void 0, void 0, function () {
            var result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, dataModel.scan({
                            lastKey: {
                                _pkey: 'TestPopulation',
                                _skey: 'TestPopulation-1'
                            },
                            limit: 3
                        })];
                    case 1:
                        result = _a.sent();
                        expect(result).toEqual(expect.arrayContaining([
                            expect.objectContaining({ _pkey: 'TestPopulation', _skey: 'TestPopulation-2' })
                        ]));
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('update testing', function () {
        test('update add new body', function () { return __awaiter(void 0, void 0, void 0, function () {
            var key, body, result, data;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        key = { _pkey: 'TestPopulation', _skey: 'TestPopulation-1' };
                        body = {
                            man: 5000,
                            woman: 1000
                        };
                        return [4 /*yield*/, dataModel.update(key, body)];
                    case 1:
                        result = _a.sent();
                        // expected return
                        expect(result).toMatchObject(__assign(__assign({}, key), body));
                        return [4 /*yield*/, docClient.get({ TableName: TABLE, Key: key }).promise()];
                    case 2:
                        data = _a.sent();
                        expect(data.Item).toMatchObject(__assign(__assign({}, key), body));
                        expect(data.Item).toHaveProperty('country');
                        expect(data.Item).toHaveProperty('population');
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('patch testing', function () {
        test('patch nest attribute', function () { return __awaiter(void 0, void 0, void 0, function () {
            var key, duration, result, data;
            var _a, _b, _c;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        key = { _pkey: 'Album1', _skey: 'Album1#Virus#Track4' };
                        duration = 200;
                        return [4 /*yield*/, dataModel.patch(key, {
                                'attribute.duration': duration
                            })];
                    case 1:
                        result = _d.sent();
                        // expected return
                        expect(result).toMatchObject(__assign({}, key));
                        return [4 /*yield*/, docClient.get({ TableName: TABLE, Key: key }).promise()];
                    case 2:
                        data = _d.sent();
                        // console.log('updated Data: ', data)
                        expect((_a = data.Item) === null || _a === void 0 ? void 0 : _a.artist).toBe('Virus');
                        expect((_b = data.Item) === null || _b === void 0 ? void 0 : _b.attribute.duration).toBe(200);
                        expect((_c = data.Item) === null || _c === void 0 ? void 0 : _c.attribute.country).toBe('Thailand');
                        return [2 /*return*/];
                }
            });
        }); });
        test('patch nest attribute with array', function () { return __awaiter(void 0, void 0, void 0, function () {
            var key, tags, result, data;
            var _a, _b, _c, _d;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        key = { _pkey: 'Album1', _skey: 'Album1#Virus#Track5' };
                        tags = ['cc', 'dd'];
                        return [4 /*yield*/, dataModel.patch(key, {
                                'attribute.tags': tags
                            })];
                    case 1:
                        result = _e.sent();
                        // expected return
                        expect(result).toMatchObject(__assign({}, key));
                        return [4 /*yield*/, docClient.get({ TableName: TABLE, Key: key }).promise()];
                    case 2:
                        data = _e.sent();
                        // console.log('updated Data: ', data)
                        expect((_a = data.Item) === null || _a === void 0 ? void 0 : _a.artist).toBe('Virus');
                        expect((_b = data.Item) === null || _b === void 0 ? void 0 : _b.attribute.tags).toContain('cc');
                        expect((_c = data.Item) === null || _c === void 0 ? void 0 : _c.attribute.tags).toContain('dd');
                        expect((_d = data.Item) === null || _d === void 0 ? void 0 : _d.attribute.country).toBe('England');
                        return [2 /*return*/];
                }
            });
        }); });
        test('patch lv1 attribute', function () { return __awaiter(void 0, void 0, void 0, function () {
            var key, result, data;
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        key = { _pkey: 'Album2', _skey: 'Album2#Araiva#Track1' };
                        return [4 /*yield*/, dataModel.patch(key, {
                                'artist': 'Virus'
                            })];
                    case 1:
                        result = _b.sent();
                        // expected return
                        expect(result).toMatchObject(__assign({}, key));
                        return [4 /*yield*/, docClient.get({ TableName: TABLE, Key: key }).promise()];
                    case 2:
                        data = _b.sent();
                        expect((_a = data.Item) === null || _a === void 0 ? void 0 : _a.artist).toBe('Virus');
                        return [2 /*return*/];
                }
            });
        }); });
    });
});
var mock = require('./payloads/mock.json');
function initDatabase() {
    var params = {
        RequestItems: {
            'Static-Table': mock.map(function (el) { return ({
                PutRequest: { Item: el }
            }); })
        }
    };
    return docClient.batchWrite(params).promise();
}
function clearDatabase() {
    var params = {
        RequestItems: {
            'Static-Table': mock.map(function (el) { return ({
                DeleteRequest: {
                    Key: {
                        _pkey: el._pkey,
                        _skey: el._skey
                    }
                }
            }); })
        }
    };
    return docClient.batchWrite(params).promise();
}
