export interface ScanQueryOptions {
    limit?: number;
    lastKey?: object;
    times?: number;
    filter?: {
        [x: string]: string;
    };
    attributes?: string;
    includeDetails?: string | boolean;
}
export interface DynamoDBUtilOptions {
    region?: string;
    timestamp?: boolean;
    accessKeyId?: string;
    secretAccessKey?: string;
}
export interface ScanOptions {
    limit?: number;
    lastKey?: object;
    times?: number;
    indexName?: string;
    filter?: KeyCondition;
    attributes?: string[];
}
export interface QueryOptions extends ScanOptions {
    keyCondition: KeyCondition;
    sort?: 'DESC' | 'ASC' | string;
}
export declare type ConditionFunction = 'equal' | 'greaterThan' | 'lessThan' | 'attributeExists' | 'attributeNotExists' | 'beginsWith' | 'contains';
export declare type KeyCondition = {
    [x: string]: {
        [cnfn in ConditionFunction | string]: string | null;
    } | string;
};
