"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DynamodbUtil = void 0;
var dynamodb_1 = require("aws-sdk/clients/dynamodb");
/**
 * ตัวช่วยทำ operation ต่างๆ บน DynamoDB
 */
var DynamodbUtil = /** @class */ (function () {
    function DynamodbUtil(table, utilOptions) {
        this.createValueKey = function (key) { return ':' + key.replace(/\./, ''); };
        this.createKeyName = function (key) { return '#' + key.split('.').join('.#'); };
        this.documentClient = new dynamodb_1.DocumentClient({
            apiVersion: 'latest',
            convertEmptyValues: true,
            // region: (utilOptions && utilOptions.region) ? utilOptions.region : undefined,
            region: (utilOptions && utilOptions.region) ? utilOptions.region : undefined,
            accessKeyId: (utilOptions && utilOptions.accessKeyId) ? utilOptions.accessKeyId : undefined,
            secretAccessKey: (utilOptions && utilOptions.secretAccessKey) ? utilOptions.secretAccessKey : undefined,
        });
        this.table = table;
        this.utilOptions = utilOptions;
        this.raw = this.documentClient;
    }
    /**
     * เรียกข้อมูลแบบ get item จาก DynamoDB
     * @param {object<[key: string]: string>} keys key หลักในการเรียกข้อมูลจากตาราง partitionKey หรือ compositeKey
     */
    DynamodbUtil.prototype.get = function (keys) {
        var params = {
            TableName: this.table,
            Key: keys,
        };
        return this.documentClient.get(params).promise().then(function (res) { return res.Item; });
    };
    /**
     * เก็บข้อมูลแบบ put item จาก DynamoDB
     * @param {body} body เนื้อหาข้อมูลที่ต้อง save ลง database
     */
    DynamodbUtil.prototype.put = function (body) {
        if (this.utilOptions && this.utilOptions.timestamp) {
            var time = new Date().getTime();
            body = __assign(__assign({}, body), { createdAt: body.createdAt || time, updatedAt: new Date().getTime() });
        }
        var params = {
            TableName: this.table,
            Item: body,
        };
        return this.documentClient.put(params).promise()
            .then(function () { return body; });
    };
    /**
     * เก็บข้อมูลแบบ update item จาก DynamoDB
     * @param {object<[key: string]: string>} keys key หลักในการเรียกข้อมูลจากตาราง partitionKey หรือ compositeKey
     * @param {body} body เนื้อหาข้อมูลที่ต้อง save ลง database
     */
    DynamodbUtil.prototype.update = function (keys, body) {
        var _this = this;
        return this.get(keys).then(function (data) {
            var putBody = __assign(__assign(__assign({}, data), body), keys);
            if (_this.utilOptions && _this.utilOptions.timestamp) {
                var time = new Date().getTime();
                body = __assign(__assign({}, body), { createdAt: (data && typeof data.createdAt === 'number') ? data.createdAt : time, updatedAt: time });
            }
            var params = { TableName: _this.table, Item: putBody };
            return _this.documentClient.put(params).promise()
                .then(function () { return putBody; });
        });
    };
    DynamodbUtil.prototype.patch = function (keys, body) {
        var _this = this;
        var names = this.convertExpressionNames(body);
        var values = this.convertExpressionValue(body, true);
        var expressions = [];
        Object.keys(body).forEach(function (key) {
            var keyName = _this.createKeyName(key);
            var valueKey = _this.createValueKey(key);
            var expressString = keyName + " = " + valueKey;
            expressions.push(expressString);
        });
        var updateExpression = 'set ' + expressions.join(' ,');
        var param = {
            TableName: this.table,
            Key: keys,
            UpdateExpression: updateExpression,
            ExpressionAttributeNames: names,
            ExpressionAttributeValues: values,
        };
        return this.documentClient.update(param).promise().then(function () { return _this.get(keys); });
    };
    /**
     * ลบข้อมูล item จาก DynamoDB
     * @param {object<[key: string]: string>} keys key หลักในการเรียกข้อมูลจากตาราง partitionKey หรือ compositeKey
     */
    DynamodbUtil.prototype.delete = function (keys) {
        var params = {
            TableName: this.table,
            Key: keys,
        };
        return this.documentClient.delete(params).promise()
            .then(function (res) {
            return keys;
        });
    };
    /**
     * Query Operation บน DynamoDB แบบรองรับ recursive รองรับได้เฉพาะ Attribute lv 1
     * @param {ScanOptions} options รายละเอียดของ Query Param
     */
    DynamodbUtil.prototype.query = function (options) {
        return __awaiter(this, void 0, void 0, function () {
            var names, values, keyCondition, filterCondition, filterNames, filterValues, projectionExpression, projectionName, param;
            return __generator(this, function (_a) {
                if (!options || !options.keyCondition) {
                    throw new Error('keyCondition filtered is required');
                }
                names = this.convertExpressionNames(options.keyCondition);
                values = this.convertExpressionValue(options.keyCondition);
                keyCondition = this.createConditionExpression(options.keyCondition);
                if (options.filter) {
                    filterNames = this.convertExpressionNames(options.filter);
                    filterValues = this.convertExpressionValue(options.filter);
                    filterCondition = this.createConditionExpression(options.filter);
                    names = Object.assign(names, filterNames);
                    values = Object.assign(values, filterValues);
                }
                if (options.attributes) {
                    projectionName = this.convertAttributeNames(options.attributes);
                    projectionExpression = this.convertProjectionName(options.attributes);
                    names = __assign(__assign({}, names), projectionName);
                }
                param = {
                    TableName: this.table,
                    IndexName: options.indexName,
                    Limit: options.limit,
                    ProjectionExpression: projectionExpression,
                    ExpressionAttributeNames: names,
                    ExpressionAttributeValues: values,
                    KeyConditionExpression: keyCondition,
                    FilterExpression: filterCondition || undefined,
                    ScanIndexForward: (options.sort === 'ASC') ? true : (options.sort === 'DESC') ? false : undefined,
                    ExclusiveStartKey: options.lastKey ? options.lastKey : undefined,
                };
                return [2 /*return*/, this.recursiveOperation('QUERY', param, options)
                        .catch(function (e) {
                        console.log(e);
                        throw new Error(e);
                    })];
            });
        });
    };
    /**
     * Scan Operation บน DynamoDB แบบรองรับ recursive
     * @param {string} options รายละเอียดของ Scan Param
     */
    DynamodbUtil.prototype.scan = function (options) {
        return __awaiter(this, void 0, void 0, function () {
            var param, names, values, filterCondition, projectionExpression, projectionName;
            return __generator(this, function (_a) {
                param = {
                    TableName: this.table,
                    IndexName: (options && options.indexName) ? options.indexName : undefined,
                    Limit: (options && options.limit) ? options.limit : undefined,
                    ProjectionExpression: (options && options.attributes) ? options.attributes.join(', ') : undefined,
                    ExclusiveStartKey: (options && options.lastKey) ? options.lastKey : undefined,
                };
                if (options && options.filter) {
                    names = this.convertExpressionNames(options.filter);
                    values = this.convertExpressionValue(options.filter);
                    filterCondition = this.createConditionExpression(options.filter);
                    param = __assign(__assign({}, param), { ExpressionAttributeNames: names, ExpressionAttributeValues: values, FilterExpression: filterCondition });
                }
                if (options && options.attributes) {
                    projectionExpression = void 0;
                    projectionName = this.convertAttributeNames(options.attributes);
                    projectionExpression = this.convertProjectionName(options.attributes);
                    param = __assign(__assign({}, param), { ProjectionExpression: projectionExpression, ExpressionAttributeNames: __assign(__assign({}, param.ExpressionAttributeNames), projectionName) });
                }
                return [2 /*return*/, this.recursiveOperation('SCAN', param, options)
                        .catch(function (e) {
                        console.log(e);
                        throw new Error(e);
                    })];
            });
        });
    };
    DynamodbUtil.convertScanQueryOptions = function (options) {
        return __assign(__assign({}, options), { attributes: (options.attributes) ? options.attributes.replace(' ', '').split(',') : undefined });
    };
    // === Private function is below == //
    /**
     * Recursive function for Scan and Query operation
     * @param fnName
     * @param param
     * @param {ScanOptions} options
     */
    DynamodbUtil.prototype.recursiveOperation = function (fnName, param, options) {
        return __awaiter(this, void 0, void 0, function () {
            var result, count, optFn, data;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        result = [];
                        count = 1;
                        _a.label = 1;
                    case 1:
                        if (!true) return [3 /*break*/, 3];
                        if (fnName === 'SCAN') {
                            optFn = this.documentClient.scan(param);
                        }
                        if (fnName === 'QUERY') {
                            optFn = this.documentClient.query(param);
                        }
                        if (!fnName || !optFn) {
                            return [2 /*return*/, []];
                        }
                        return [4 /*yield*/, optFn.promise()];
                    case 2:
                        data = _a.sent();
                        result = __spread(result, data.Items);
                        param = __assign(__assign({}, param), { ExclusiveStartKey: data.LastEvaluatedKey });
                        if (!options || options.times === undefined || options.times === null) {
                            return [2 /*return*/, result];
                        }
                        if (!data.LastEvaluatedKey) {
                            return [3 /*break*/, 3];
                        }
                        if (options.times && count === +options.times) {
                            return [3 /*break*/, 3];
                        }
                        count++;
                        return [3 /*break*/, 1];
                    case 3: return [2 /*return*/, result];
                }
            });
        });
    };
    DynamodbUtil.prototype.createConditionExpression = function (filterCondition) {
        var _this = this;
        var conditions = [];
        Object.keys(filterCondition).forEach(function (key) {
            var keyName = _this.createKeyName(key);
            var valueKey = _this.createValueKey(key);
            var value = filterCondition[key];
            var string = '';
            if (typeof value === 'string') {
                string = DynamodbUtil.mapConditionToString('equal', keyName, valueKey);
            }
            else {
                var condition = Object.keys(filterCondition[key])[0];
                var valueKey_1 = _this.createValueKey(key);
                string = DynamodbUtil.mapConditionToString(condition, keyName, valueKey_1);
            }
            conditions.push(string);
        });
        return conditions.join(' and ');
    };
    DynamodbUtil.prototype.convertExpressionValue = function (filter, isnNestObject) {
        if (isnNestObject === void 0) { isnNestObject = false; }
        if (typeof filter === 'string') {
            filter = JSON.parse(filter);
        }
        else if (typeof filter !== 'object') {
            throw new Error('filter or keyCondition is not Object or JSON');
        }
        var result = {};
        Object.keys(filter).forEach(function (key) {
            var keyName = key.replace(/\./, '');
            var value = filter[key];
            if (typeof value !== 'object' || isnNestObject) {
                result[":" + keyName] = value;
            }
            else {
                result[":" + keyName] = Object.values(value)[0];
            }
        });
        return result;
    };
    DynamodbUtil.prototype.convertExpressionNames = function (filter) {
        if (typeof filter === 'string') {
            filter = JSON.parse(filter);
        }
        else if (typeof filter !== 'object') {
            throw new Error('filter or keyCondition is not Object or JSON');
        }
        var result = {};
        Object.keys(filter).forEach(function (key) {
            var keyNames = key.split('.');
            keyNames.forEach(function (key) {
                result["#" + key] = key;
            });
        });
        return result;
    };
    DynamodbUtil.prototype.convertAttributeNames = function (attributes) {
        var result = {};
        attributes.forEach(function (key) {
            var keyNames = key.split('.');
            keyNames.forEach(function (key) {
                result["#" + key] = key;
            });
        });
        return result;
    };
    DynamodbUtil.prototype.convertProjectionName = function (attributes) {
        return attributes.map(function (attr) { return attr.split('.').map(function (name) { return '#' + name; }).join('.'); }).join(', ');
    };
    DynamodbUtil.mapConditionToString = function (condition, key, value) {
        switch (condition) {
            case 'equal':
                return key + " = " + value;
            case 'greaterThan':
                return key + " > " + value;
            case 'lessThan':
                return key + " < " + value;
            case 'attributeExists':
                return "attribute_exists(" + key + ")";
            case 'attributeNotExists':
                return "attribute_not_exists(" + key + ")";
            case 'beginsWith':
                return "begins_with(" + key + ", " + value + ")";
            case 'contains':
                return "contains(" + key + ", " + value + ")";
            default:
                return key + " = " + value;
        }
    };
    return DynamodbUtil;
}());
exports.DynamodbUtil = DynamodbUtil;
